/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by http://code.google.com/p/protostuff/ ... DO NOT EDIT!
// Generated from protobuf

package org.apache.drill.exec.proto.beans;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import com.dyuproject.protostuff.GraphIOUtil;
import com.dyuproject.protostuff.Input;
import com.dyuproject.protostuff.Message;
import com.dyuproject.protostuff.Output;
import com.dyuproject.protostuff.Schema;

public final class StackTraceElementWrapper implements Externalizable, Message<StackTraceElementWrapper>, Schema<StackTraceElementWrapper>
{

    public static Schema<StackTraceElementWrapper> getSchema()
    {
        return DEFAULT_INSTANCE;
    }

    public static StackTraceElementWrapper getDefaultInstance()
    {
        return DEFAULT_INSTANCE;
    }

    static final StackTraceElementWrapper DEFAULT_INSTANCE = new StackTraceElementWrapper();

    
    private String className;
    private String fileName;
    private int lineNumber;
    private String methodName;
    private Boolean isNativeMethod;

    public StackTraceElementWrapper()
    {
        
    }

    // getters and setters

    // className

    public String getClassName()
    {
        return className;
    }

    public StackTraceElementWrapper setClassName(String className)
    {
        this.className = className;
        return this;
    }

    // fileName

    public String getFileName()
    {
        return fileName;
    }

    public StackTraceElementWrapper setFileName(String fileName)
    {
        this.fileName = fileName;
        return this;
    }

    // lineNumber

    public int getLineNumber()
    {
        return lineNumber;
    }

    public StackTraceElementWrapper setLineNumber(int lineNumber)
    {
        this.lineNumber = lineNumber;
        return this;
    }

    // methodName

    public String getMethodName()
    {
        return methodName;
    }

    public StackTraceElementWrapper setMethodName(String methodName)
    {
        this.methodName = methodName;
        return this;
    }

    // isNativeMethod

    public Boolean getIsNativeMethod()
    {
        return isNativeMethod;
    }

    public StackTraceElementWrapper setIsNativeMethod(Boolean isNativeMethod)
    {
        this.isNativeMethod = isNativeMethod;
        return this;
    }

    // java serialization

    public void readExternal(ObjectInput in) throws IOException
    {
        GraphIOUtil.mergeDelimitedFrom(in, this, this);
    }

    public void writeExternal(ObjectOutput out) throws IOException
    {
        GraphIOUtil.writeDelimitedTo(out, this, this);
    }

    // message method

    public Schema<StackTraceElementWrapper> cachedSchema()
    {
        return DEFAULT_INSTANCE;
    }

    // schema methods

    public StackTraceElementWrapper newMessage()
    {
        return new StackTraceElementWrapper();
    }

    public Class<StackTraceElementWrapper> typeClass()
    {
        return StackTraceElementWrapper.class;
    }

    public String messageName()
    {
        return StackTraceElementWrapper.class.getSimpleName();
    }

    public String messageFullName()
    {
        return StackTraceElementWrapper.class.getName();
    }

    public boolean isInitialized(StackTraceElementWrapper message)
    {
        return true;
    }

    public void mergeFrom(Input input, StackTraceElementWrapper message) throws IOException
    {
        for(int number = input.readFieldNumber(this);; number = input.readFieldNumber(this))
        {
            switch(number)
            {
                case 0:
                    return;
                case 1:
                    message.className = input.readString();
                    break;
                case 2:
                    message.fileName = input.readString();
                    break;
                case 3:
                    message.lineNumber = input.readInt32();
                    break;
                case 4:
                    message.methodName = input.readString();
                    break;
                case 5:
                    message.isNativeMethod = input.readBool();
                    break;
                default:
                    input.handleUnknownField(number, this);
            }   
        }
    }


    public void writeTo(Output output, StackTraceElementWrapper message) throws IOException
    {
        if(message.className != null)
            output.writeString(1, message.className, false);

        if(message.fileName != null)
            output.writeString(2, message.fileName, false);

        if(message.lineNumber != 0)
            output.writeInt32(3, message.lineNumber, false);

        if(message.methodName != null)
            output.writeString(4, message.methodName, false);

        if(message.isNativeMethod != null)
            output.writeBool(5, message.isNativeMethod, false);
    }

    public String getFieldName(int number)
    {
        switch(number)
        {
            case 1: return "className";
            case 2: return "fileName";
            case 3: return "lineNumber";
            case 4: return "methodName";
            case 5: return "isNativeMethod";
            default: return null;
        }
    }

    public int getFieldNumber(String name)
    {
        final Integer number = __fieldMap.get(name);
        return number == null ? 0 : number.intValue();
    }

    private static final java.util.HashMap<String,Integer> __fieldMap = new java.util.HashMap<String,Integer>();
    static
    {
        __fieldMap.put("className", 1);
        __fieldMap.put("fileName", 2);
        __fieldMap.put("lineNumber", 3);
        __fieldMap.put("methodName", 4);
        __fieldMap.put("isNativeMethod", 5);
    }
    
}
