/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by http://code.google.com/p/protostuff/ ... DO NOT EDIT!
// Generated from protobuf

package org.apache.drill.exec.proto.beans;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

import com.dyuproject.protostuff.GraphIOUtil;
import com.dyuproject.protostuff.Input;
import com.dyuproject.protostuff.Message;
import com.dyuproject.protostuff.Output;
import com.dyuproject.protostuff.Schema;

public final class StreamProfile implements Externalizable, Message<StreamProfile>, Schema<StreamProfile>
{

    public static Schema<StreamProfile> getSchema()
    {
        return DEFAULT_INSTANCE;
    }

    public static StreamProfile getDefaultInstance()
    {
        return DEFAULT_INSTANCE;
    }

    static final StreamProfile DEFAULT_INSTANCE = new StreamProfile();

    
    private long records;
    private long batches;
    private long schemas;

    public StreamProfile()
    {
        
    }

    // getters and setters

    // records

    public long getRecords()
    {
        return records;
    }

    public StreamProfile setRecords(long records)
    {
        this.records = records;
        return this;
    }

    // batches

    public long getBatches()
    {
        return batches;
    }

    public StreamProfile setBatches(long batches)
    {
        this.batches = batches;
        return this;
    }

    // schemas

    public long getSchemas()
    {
        return schemas;
    }

    public StreamProfile setSchemas(long schemas)
    {
        this.schemas = schemas;
        return this;
    }

    // java serialization

    public void readExternal(ObjectInput in) throws IOException
    {
        GraphIOUtil.mergeDelimitedFrom(in, this, this);
    }

    public void writeExternal(ObjectOutput out) throws IOException
    {
        GraphIOUtil.writeDelimitedTo(out, this, this);
    }

    // message method

    public Schema<StreamProfile> cachedSchema()
    {
        return DEFAULT_INSTANCE;
    }

    // schema methods

    public StreamProfile newMessage()
    {
        return new StreamProfile();
    }

    public Class<StreamProfile> typeClass()
    {
        return StreamProfile.class;
    }

    public String messageName()
    {
        return StreamProfile.class.getSimpleName();
    }

    public String messageFullName()
    {
        return StreamProfile.class.getName();
    }

    public boolean isInitialized(StreamProfile message)
    {
        return true;
    }

    public void mergeFrom(Input input, StreamProfile message) throws IOException
    {
        for(int number = input.readFieldNumber(this);; number = input.readFieldNumber(this))
        {
            switch(number)
            {
                case 0:
                    return;
                case 1:
                    message.records = input.readInt64();
                    break;
                case 2:
                    message.batches = input.readInt64();
                    break;
                case 3:
                    message.schemas = input.readInt64();
                    break;
                default:
                    input.handleUnknownField(number, this);
            }   
        }
    }


    public void writeTo(Output output, StreamProfile message) throws IOException
    {
        if(message.records != 0)
            output.writeInt64(1, message.records, false);

        if(message.batches != 0)
            output.writeInt64(2, message.batches, false);

        if(message.schemas != 0)
            output.writeInt64(3, message.schemas, false);
    }

    public String getFieldName(int number)
    {
        switch(number)
        {
            case 1: return "records";
            case 2: return "batches";
            case 3: return "schemas";
            default: return null;
        }
    }

    public int getFieldNumber(String name)
    {
        final Integer number = __fieldMap.get(name);
        return number == null ? 0 : number.intValue();
    }

    private static final java.util.HashMap<String,Integer> __fieldMap = new java.util.HashMap<String,Integer>();
    static
    {
        __fieldMap.put("records", 1);
        __fieldMap.put("batches", 2);
        __fieldMap.put("schemas", 3);
    }
    
}
